<!DOCTYPE html>
<html lang="ja">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

  <!-- Bootstrap CSS -->
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
  <title>Todo アプリ</title>
</head>
<body>
  <nav class="navbar navbar-dark bg-dark">
      <a class="navbar-brand" id = "username" href="#">AさんのTodoリスト</a>
      <button class="btn btn-outline-dark bg-white" onclick="logout()">ログアウト</button>
  </nav>
  <div class="container">
  <br>
  <table id = "todo_table" class="table table-bordered text-center">
    <tr class = "bg-primary text-white">
      <th>状態</th><th>Todo</th><th>作成日時</th><th></th>
    </tr>
  </table>

  <div class="card">
    <div class="card-header bg-info text-white text-center">新規Todo</div>
    <div class="card-body bg-light">
      <form name="todo_form" onsubmit="createTodo()">
        <div class="form-group">
          <input name="title" class="form-control" type="text">
        </div>
        <input type="submit" class="btn btn-info btn-lg mx-auto d-block" value="登録"/>
      </form>
    </div>
  </div>
  </div>
</body>


<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"  crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>
<script>
var url = "http://localhost:8080/todo";

function delete_alert(id){
  var button = event.target;
	if(window.confirm('削除しますか？')){
    delete_todo(button,id);
	}
}

$(function(){
  $.ajax({url : url,
    xhrFields: {
       withCredentials: true
    }
  })
  .then(
    function(data){
      $.each(data, function(index, todo) {
        var table = document.getElementById("todo_table");
        var tr = document.createElement("tr");
        var tr_class = todo.status == 1 ? "table-success" : "table-active";
        tr.classList.add(tr_class);
        var checked = todo.status == 1 ? "checked" : ""
        var date_parsed = new Date(Date.parse(todo.created_by)).toLocaleString();
        tr.innerHTML =  "<td><input type='checkbox' onchange ='edit_todo("+ todo.id + ")'" +  checked + "></td><td>"
          + todo.title + "</td><td>" + date_parsed
          + "</td><td><button class='btn btn-danger' onclick='delete_alert(" + todo.id + ")'>削除</button></td>"
        table.appendChild(tr);

      })
    },
    function(){
      location.href = "login.html";
    }
  )

  $.ajax("http://localhost:3000/user")
  .then(
    function(data){
      var username = document.getElementById("username");
      username.innerText = data.email + "さんのTodoリスト"
    },
    function(){
      console.log("読み込みエラー")
    }
  )

}
)

function createTodo(){
  var title = document.todo_form.title.value;
  if (title == "") {
    return;
  }
  $.ajax({
    type : "POST",
    url : "http://localhost:3000/todo",
    data : {title : title}
  }).then(
    function(){
      window.location.href = "index.html"
    },
    function(){
      console.log("error")
    }
  )
}

function edit_todo(id){
  var new_status = event.target.checked ? 1 : 0;
  $.ajax({
    type : "PUT",
    url : "http://localhost:3000/todo/" + id,
    data : {id : id, title : "test", created_by: "test",status : new_status}
  }).then(
    function(){
      window.location.href = "index.html"
    },
    function(){
      console.log("error")
    }
  )
}

function delete_todo(target, id){
  $.ajax({
    type : "DELETE",
    url : "http://localhost:3000/todo/" + id,
  }).then(
    function(){
      window.location.href = "index.html"
    },
    function(){
      console.log("error")
    }
  )
}

function logout(){
  $.ajax({
    type : "GET",
    url : "http://localhost:8080/logout",
    xhrFields: {
       withCredentials: true
    }
  }).then(
    function(){
      window.location.href = "login.html"
    },
    function(){
      console.log("error")
    }
  )
}
</script>

</html>
